﻿Module Module_Utils

    Friend GCI As Globalization.CultureInfo = Globalization.CultureInfo.InvariantCulture

    ' ==================================================================================================
    '  ARRAY RESAMPLE
    ' ==================================================================================================
    Friend Sub Array_Resample(ByRef aold() As Single, ByVal NewSize As Int32)
        Dim OldSize As Int32 = aold.Length
        If OldSize < 2 Then Return
        If NewSize < 1 Then Return
        If NewSize = OldSize Then Return
        Dim k As Double = NewSize / (OldSize - 1)
        Dim anew(NewSize - 1) As Single
        If NewSize > OldSize Then
            For i As Int32 = 0 To OldSize - 2
                Dim j1 As Int32 = CInt(i * k)
                Dim j2 As Int32 = CInt((i + 1) * k) - 1
                For j As Int32 = j1 To j2
                    anew(j) = InterpolateAndExtrapolate(j1, j2, j, aold(i), aold(i + 1))
                Next
            Next
        Else
            Dim n As Int32
            Dim acc As Single
            For i As Int32 = 0 To NewSize - 1
                n = 0
                acc = 0
                For j As Int32 = CInt(i / k) To CInt((i + 1) / k) - 1
                    acc += aold(j)
                    n += 1
                Next
                anew(i) = acc / n
            Next
        End If
        aold = anew
    End Sub

    ' =======================================================================================================
    '  Interpolation function
    ' -------------------------------------------------------------------------------------------------------
    '  Example (returned value x is 30)
    '   I1=1     ix=3     I2=5
    '   V1=10    x=??     V2=50
    ' =======================================================================================================
    Friend Function InterpolateAndExtrapolate(ByVal i1 As Single, ByVal i2 As Single, ByVal ix As Single, _
                                              ByVal v1 As Single, ByVal v2 As Single) As Single
        If i2 = i1 Then Return v1
        Return v1 + (v2 - v1) * (ix - i1) / (i2 - i1)
    End Function


End Module
